const FeedListView = Vue.component("feed-list-view", {
  data: function () {
    return {
      feed_list: [],
      new_feed_url: "https://linuxfr.org/news.atom"
    };
  },
  methods: {
    fetchFeeds: function() {
      let component = this;

      fetch("/api/feeds/")
      .then(function(response) {
        return response.json();
      })
      .then(function(json) {
        component.feed_list = json;
      })
      .catch(function(err) {
        console.log(err);
      })
    },
    onSubmit: function () {
      let c = this,
          fd = new FormData();

      fd.set('new_feed_url', this.new_feed_url);

      fetch("/api/feeds/new/", {
        method: "POST",
        body: fd
      })
      .then(function(response) {
        console.log(response);
        c.fetchFeeds();
      })
      .catch(function(err) {
        console.log(err);
      })
    }
  },
  beforeMount: function () {
    return this.fetchFeeds();
  },
  template:`
  <div>
    <ul>
      <li v-for="feed in feed_list">{{ feed.title }}</li>
    </ul>
    <form v-on:submit.prevent="onSubmit" action="/api/feeds/new/" method="POST">
      <input v-model="new_feed_url" name="feed_url">
      <button type="submit">Add</button>
    </form>
  </div>
  `
})

const router = new VueRouter({
  routes: [{
    path: '/',
    component: FeedListView
  }]
})

const app = new Vue({
  router
}).$mount("#app")
